<?php
define('IN_PHPBB', true);
define('BB_SCRIPT', 'rss');
define('BB_ROOT', './');
require(BB_ROOT ."common.php");

if (!$bb_cfg['rss']) bb_die('RSS лента отключена.');

if (isset($_GET['f']))
{
	$sql = DB()->fetch_rowset("
	SELECT t.topic_id, t.topic_title, t.forum_id, t.topic_poster, t.topic_time, u.user_id, u.username,
	f.forum_name, f.forum_id, f.rss
		FROM ".BB_TOPICS." t, ".BB_USERS." u, ".BB_FORUMS." f
		WHERE t.topic_poster = u.user_id AND t.forum_id = ".(int) $_GET['f']." AND t.forum_id = f.forum_id
		GROUP BY t.topic_id DESC
	LIMIT 0, 20");
	if (!$sql or !$sql[0]['rss']) bb_die('Ошибка при выводе тем');
	$name = $sql[0]['forum_name'];
}else{
	if (!$sql = CACHE('bb_cache')->get('rss'))
	{
		$sql = DB()->fetch_rowset("
		SELECT t.topic_id, t.topic_title, t.topic_poster, t.topic_time, t.forum_id, u.user_id, u.username,
		f.forum_id, f.rss
			FROM ".BB_TOPICS." t, ".BB_USERS." u, ".BB_FORUMS." f
			WHERE t.topic_poster = u.user_id AND f.forum_id = t.forum_id AND f.rss = 1
		GROUP BY t.topic_id DESC LIMIT 0, 20");

		CACHE('bb_cache')->set('rss', $sql, 24000);
		if (!$sql) bb_die('Ошибка при выводе тем');
	}
	$name = $_SERVER['SERVER_NAME'];
}
header("Content-Type: text/xml");
$html = '';
$html .= '<?xml version="1.0" encoding="UTF-8"?>
	<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/">
	<channel>
	<title>RSS Feed - '.$name.'</title>
	<link>http://'.$_SERVER['SERVER_NAME'].'</link>
<language>ru</language>';
foreach($sql as $row)
{
	$html .= '
	<item>
		<guid>http://'.$_SERVER['SERVER_NAME'].'/viewtopic.php?t='.$row['topic_id'].'</guid>
		<title>'.$row['topic_title'].'</title>
		<dc:creator>'.$row['username'].'</dc:creator>
		<pubDate>'.gmdate('M d Y H:i:s', $row['topic_time']).'</pubDate>
		<link>http://'.$_SERVER['SERVER_NAME'].'/viewtopic.php?t='.$row['topic_id'].'</link>
	</item>';
}
$html .='</channel>
</rss>';
echo $html;